CoordNonZero = function(wk, k, j, X, tau)
# Coordinate Descent for w_kj with inital value wkj (j != 0)
{
  source("D1P.R")
  source("D1N.R")
  source("D2PN.R")
  source("Qvalue.R")
  ini = wk[k,j]
  #print(paste("initial:", ini))
  epsNewton = 10^-5
  #loop = 0
#================ Positive Q function  
  repeat
  { 
    #loop = loop+1
    #print(paste("Loop:",loop))
    D1 = D1P(wk, k, j, ini, X, tau)
    D2 = D2PN(wk, k, j, ini, X, tau)
    #print(D1^2/D2)
    if(abs(D1^2/D2) < epsNewton) break
    ini = ini - D1/D2
  }
  Q0 = Qvalue(wk, k, j, 0, X, tau)
  #print(paste("iniP: ", ini))
  if(ini > 0)
  {
    QP = Qvalue(wk, k, j, ini, X, tau) - gamma*ini - rho*ini^2/2 
    iniP = ini
    }
  else
  {
    QP = Q0
    iniP = 0
  }
#=============Negative Q function  
  ini = wk[k,j]
  repeat
  {
    D1 = D1N(wk, k, j, ini, X, tau)
    D2 = D2PN(wk, k, j, ini, X, tau)
    #print(D1^2/D2)
    if(abs(D1^2/D2) < epsNewton) break
    ini = ini - D1/D2
  }
  #print(paste("iniN: ", ini))
  if(ini < 0)
  {
    QN = Qvalue(wk, k, j, ini, X, tau) + gamma*ini - rho*ini^2/2 
    iniN = ini
  }
  else
  {
    QN = Q0
    iniN = 0
  }
#===========Compare
if (QP > QN) 
  {
    #wk[k,j] <<- iniP
    return (iniP)
  }
  {
    #wk[k,j] <<- iniN
    return (iniN)
  }  
}