MM = function(t, tau, w, gamma, rho, K)
#w = w(s), gamma = vector gamma  
#t always choose t = X
{
  epsMM = 1e-6 #Threashold in MM algorithm
  source("Pik.R")
  #source("Newton.R")
  source("Newton2.R")
  #source("Halley.R")
  source("Fs.R")
  w1 = w
  d = dim(t)[2] #d = p+1
  n = dim(t)[1]
  P = matrix(rep(0, n*K), ncol=K)
  H = K-1
  Tau = colSums(tau)
  #w0 = matrix(rep(0, d*H), ncol = d)
  #matrix of parameters in gating functions
  repeat
  { 
    w0 = w1
    P = Pik(n, K, t, w0)
    PI = colSums(P)
    for (k in 1:H)
    {
    w1[k,1] = w0[k,1] + log(Tau[k]/PI[k])/d
    for (j in 2:d)
      {
        #w1[k,j] = EH(t, tau, P, w0, k, j, gamma[k], rho)
        w1[k,j] = NR(t, tau, P, w0, k, j, gamma[k], rho)
      }
    }
    F1 = Fs(t, tau, gamma, rho, w1, K)
    F0 = Fs(t, tau, gamma, rho, w0, K)
    #print(F0)
    if((F1-F0)<epsMM) break
  }
  return (w0)
}