NR = function(X, tau, pikm, wm, k, j, gammak, rho)
  #j from 2 to (p+1)
  #k from 1 to K-1
  #matrix pikm bases on input wm = pi(x;wm) = pi[xi,wm_k]
{
  source("GsP.R")
  source("GsN.R")
  d = dim(X)[2] #d = p+1
  epsNR = 1e-6 #Threshold for NR algorithm
  Vkj = t(as.matrix(tau[,k]))%*%(as.matrix(X[,j]))
  Pkm = pikm[,k]#take columm k from pikm (pik in step M of MM algorithm)
  PkmX = Pkm*X[,j]
  PkmX2 = Pkm*(X[,j]^2)
  #===========Compute maximize of Gs Positive================
  u2 = wm[k,j] #initial value of NR algorithm
  G2 = GsP(u2, X, tau, pikm, wm, k, j, gammak, rho)
  #print(paste("Initial Gs value: ", G2))
  repeat
  {
    u1 = u2
    #G1 = G2
    ExP = exp(d*(u1-wm[k,j])*X[,j])
    d1 = Vkj - as.numeric(as.matrix(t(PkmX))%*%as.matrix(ExP)-u1*rho - gammak)
    d2 = -(d*as.numeric(as.matrix(t(PkmX2))%*%as.matrix(ExP)+rho))
    u2 = u1 - d1/d2
    G2 = GsP(u2, X, tau, pikm, wm, k, j, gammak, rho)
    #print(G2-G1)
    if(abs(d1)<epsNR) break
  }
  uP = u2
  GP = G2
  #d1 = Vkj - as.numeric(as.matrix(t(PkmX))%*%as.matrix(ExP)-u2*Ekj)
  #print(paste("Derivative value 1: ", d1))
  #print(paste("Value 1: ", G2))
  #===========Compute maximize of Gs Negative================
  u2 = wm[k,j] #initial value of NR algorithm
  G2 = GsN(u2, X, tau, pikm, wm, k, j, gammak, rho)
  #print(paste("Initial Gs value: ", G2))
  repeat
  {
    u1 = u2
    #G1 = G2
    ExP = exp(d*(u1-wm[k,j])*X[,j])
    d1 = Vkj - as.numeric(as.matrix(t(PkmX))%*%as.matrix(ExP)-u1*rho + gammak)
    d2 = -(d*as.numeric(as.matrix(t(PkmX2))%*%as.matrix(ExP)+rho))
    u2 = u1 - d1/d2
    G2 = GsN(u2, X, tau, pikm, wm, k, j, gammak, rho)
    #print(G2-G1)
    if(abs(d1)<epsNR) break
  }
  uN = u2
  GN = G2
  #=============Compare with Gs(0|wm) to find the maximizer of Gs(u|wm) function
  ExP = exp(-d*wm[k,j]*X[,j])
  Gs0 = - as.numeric(as.matrix(t(Pkm))%*%as.matrix(ExP))/d
  if(uP < 0)
  {
    uP = 0
    GP = Gs0
  }
  if(uN > 0)
  {
    uN = 0
    GN = Gs0
  }
  if ((GP > Gs0)&(GP > GN)) return (uP)
  if ((GN > Gs0)&(GN > GP)) return (uN)
  return(0)
}
